
function GiveUnits(teammate)
    -- Give selected units to the ally in postion "teammate"
    LOG("GiveUnits() called")
    
	-- Boolean control over whether or not you can donate units to a computer ally.  Handy to set to TRUE for testing.
	local allowDonationToComputer = false

    local panic = (teammate == 7)
    local teammateCount = 0
    for index, playerInfo in GetArmiesTable().armiesTable do
        if ((playerInfo.civilian) or (index == GetFocusArmy()) or (not (playerInfo.human or allowDonationToComputer))) then continue end
        if IsAlly(GetFocusArmy(), index) then
            teammateCount = teammateCount + 1
			if (not (playerInfo.outOfGame)) then
				if ((teammateCount == teammate) or (panic)) then
					if panic then
						UISelectionByCategory("ALLUNITS", false, false, false, false)
						GiveResources(7)
					end
					SimCallback({Func="GiveUnitsToPlayer", Args={ From=GetFocusArmy(), To=index},} , true)
					break
				end
            end
        end
    end
end

function GiveResources(teammate)
    -- Give selected units to the ally in postion "teammate"
    LOG("GiveResources() called")

	-- Boolean control over whether or not you can donate units to a computer ally.  Handy to set to TRUE for testing.
	local allowDonationToComputer = false
    
    local panic = (teammate == 7)
    local teammateCount = 0
	local amount = 75.0
    for index, playerInfo in GetArmiesTable().armiesTable do
        if ((playerInfo.civilian) or (index == GetFocusArmy()) or (not (playerInfo.human or allowDonationToComputer))) then continue end
        if IsAlly(GetFocusArmy(), index) then
            teammateCount = teammateCount + 1
			if (not (playerInfo.outOfGame)) then
				if ((teammateCount == teammate) or (panic)) then
					if panic then
						amount = 100.0
					end
					SimCallback({Func="GiveResourcesToPlayer", Args={ From=GetFocusArmy(), To=index, Mass=amount/100.0, Energy=amount/100.0},} , true)
					break
				end
            end
        end
    end
end

function Init()
    LOG("In init of OneKeyUnitDonation")

	local newSelectionsMap = {    
	}
	IN_AddKeyMapTable(newSelectionsMap)

    local replacementMap = {
    ['Ctrl-F1']          = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(1)'}, 
    ['Ctrl-F2']          = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(2)'}, 
    ['Ctrl-F3']          = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(3)'}, 
    ['Ctrl-F4']          = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(4)'}, 
    ['Ctrl-F5']          = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(5)'}, 
    ['Ctrl-F6']          = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(6)'}, 
    ['Ctrl-P']           = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveUnits(7)'}, 
    ['Ctrl-Shift-F1']	 = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveResources(1)'}, 
    ['Ctrl-Shift-F2']	 = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveResources(2)'}, 
    ['Ctrl-Shift-F3']	 = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveResources(3)'}, 
    ['Ctrl-Shift-F4']	 = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveResources(4)'}, 
    ['Ctrl-Shift-F5']	 = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveResources(5)'}, 
    ['Ctrl-Shift-F6']	 = {action =	 'UI_Lua import("/mods/onekeyunitdonation/onekeyunitdonation.lua").GiveResources(6)'}, 
    }

    IN_AddKeyMapTable(replacementMap)
end
